<template>
  <b-container fluid>
    <b-card :header="caption">
      <div slot="header">
        Клиенты
        <div class="card-header-actions">
          <button :disabled="isDisabled()" class="btn btn-primary btn-sm" @click="openAddingModal">
            <i class="icon-plus"></i>
          </button>
        </div>
      </div>
      <nav>
        <b-form-input v-model="filter" placeholder="Поиск..." />
      </nav>
      <b-table :hover="hover" :striped="striped" :bordered="bordered" :small="small" @filtered="onFiltered" :filter="filter" responsive :items="items" :fields="fields" :current-page="currentPage" :per-page="perPage">
        <template slot="birthday" slot-scope="data">
          <div v-if="data.item.birthday">
            {{ dateFormat(data.item.birthday) }}
          </div>
        </template>
        <template slot="action" slot-scope="data">
          <b-button size="sm" @click.stop="info(data.item)" class="mr-1 tableActionbtn" :disabled="isDisabled()">
            <i class="icon-pencil"></i>
          </b-button>
        </template>
      </b-table>
      <nav>
        <b-pagination :total-rows="rowCount" :per-page="perPage" v-model="currentPage" prev-text="Предыдущая" next-text="Следующая" hide-goto-end-buttons/>
      </nav>
    </b-card>

    <b-modal id="modalInfo" @hide="resetModal" title="Редактирование клиента" centered @ok="edit" ok-only>
      <h6>Клиент: {{modalInfo.name}} {{modalInfo.lastName}}</h6>
      <b-container fluid>
        <b-form-group>
          <label>Имя *</label>
          <b-form-input type="text" name="name2" placeholder="Имя" v-model="modalInfo.name" v-validate="'required'"></b-form-input>
          <span v-show="errors.has('name2')" class="text-danger">{{ errors.first('name2') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Фамилия *</label>
          <b-form-input type="text" name="lastName2" placeholder="Фамилия" v-model="modalInfo.lastName" v-validate="'required'"></b-form-input>
          <span v-show="errors.has('lastName2')" class="text-danger">{{ errors.first('lastName2') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Дата рождения</label>
          <!-- <datepicker :language="ru" v-model="modalInfo.birthday" name="modalInfo.birthday"></datepicker> -->
          <!-- <b-form-input type="text" placeholder="Дата рождения" v-model="modalInfo.birthday" name="birthday"></b-form-input> -->
          <masked-input v-model="modalInfo.birthday" class="form-control" mask="\ 11.11.1111" placeholder="Дата рождения" name="modalInfo.birthday"></masked-input>
          <span v-show="!validBirthday" class="text-danger">Написано не корректно</span>
        </b-form-group>
        <b-form-group>
          <label>Телефон *</label>
          <masked-input v-model="modalInfo.phone" class="form-control" mask="\8 (111) 111-11-11" placeholder="Телефон" name="phone2" v-validate="'required'"></masked-input>
          <span v-show="errors.has('phone2')" class="text-danger">{{ errors.first('phone2') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Email</label>
          <b-form-input v-validate="'email'" type="text" name="email2" placeholder="example@mail.com" v-model="modalInfo.email"></b-form-input>
          <span v-show="errors.has('email2')" class="text-danger">{{ errors.first('email2') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Город</label>
          <b-form-select type="text" name="city2" placeholder="Город" v-model="modalInfo.city" :options="cities"></b-form-select>
        </b-form-group>
        <b-form-group>
          <label>ИИН</label>
          <b-form-input type="text" placeholder="" v-model="modalInfo.IIN"></b-form-input>
        </b-form-group>
        <b-form-group>
          <label>БИН</label>
          <b-form-input type="text" placeholder="" v-model="modalInfo.BIN"></b-form-input>
        </b-form-group>
        <b-form-group>
          <label>Юр адрес</label>
          <b-form-input type="text" placeholder="Юр адрес" v-model="modalInfo.jurAddres"></b-form-input>
        </b-form-group>
        <b-form-group>
          <label>Название компании</label>
          <b-form-input type="text" placeholder="Название компании" v-model="modalInfo.companyName"></b-form-input>
        </b-form-group>
        <b-btn class="mt-3" variant="primary" block @click="edit">Изменить</b-btn>
        <!-- <b-btn class="mt-3" variant="outline-danger" block @click="deleting(modalInfo._id)">Удалить</b-btn> -->
      </b-container>
      <div slot="modal-footer" class="w-100">
      </div>
    </b-modal>
    <b-modal id="addingModal" @hide="resetModal" title="Добавление клиента" centered @ok="adding" ok-only>
      <b-container fluid>
        <b-form-group>
          <label>Имя *</label>
          <b-form-input type="text" name="name" placeholder="Имя" v-model="addedUser.name" v-validate="'required'"></b-form-input>
          <span v-show="errors.has('name')" class="text-danger">{{ errors.first('name') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Фамилия *</label>
          <b-form-input type="text" name="lastName" placeholder="Фамилия" v-model="addedUser.lastName" v-validate="'required'"></b-form-input>
          <span v-show="errors.has('lastName')" class="text-danger">{{ errors.first('lastName') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Дата рождения</label>
          <masked-input v-model="addedUser.birthday" class="form-control" mask="\ 11.11.1111" placeholder="Дата рождения" name="birthday"></masked-input>
          <span v-show="!validBirthday" class="text-danger">Написано не корректно</span>
          <!-- <datepicker :language="ru" v-model="addedUser.birthday" name="addedUser.birthday"></datepicker> -->
          <!-- <b-form-input type="text" name="addedUser.birthday" placeholder="Дата рождения" v-model="addedUser.birthday"></b-form-input> -->
        </b-form-group>
        <b-form-group>
          <label>Телефон *</label>
          <masked-input v-model="addedUser.phone" class="form-control" mask="\8 (111) 111-11-11" placeholder="Телефон" name="phone" v-validate="'required'"></masked-input>
          <span v-show="errors.has('phone')" class="text-danger">{{ errors.first('phone') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Email</label>
          <b-form-input v-validate="'email'" type="text" name="email" placeholder="example@mail.com" v-model="addedUser.email"></b-form-input>
          <span v-show="errors.has('email')" class="text-danger">{{ errors.first('email') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Город</label>
          <b-form-select type="text" name="addedUser.city" placeholder="Город" v-model="addedUser.city" :options="cities"></b-form-select>
        </b-form-group>
        <b-form-group>
          <label>ИИН</label>
          <b-form-input type="text" placeholder="" v-model="addedUser.IIN"></b-form-input>
        </b-form-group>
        <b-form-group>
          <label>БИН</label>
          <b-form-input type="text" placeholder="" v-model="addedUser.BIN"></b-form-input>
        </b-form-group>
        <b-form-group>
          <label>Юр адрес</label>
          <b-form-input type="text" placeholder="Юр адрес" v-model="addedUser.jurAddres"></b-form-input>
        </b-form-group>
        <b-form-group>
          <label>Название компании</label>
          <b-form-input type="text" placeholder="Название компании" v-model="addedUser.companyName"></b-form-input>
        </b-form-group>
        <b-btn class="mt-3" variant="primary" block @click="adding">Добавить</b-btn>
      </b-container>
      <div slot="modal-footer" class="w-100">
      </div>
    </b-modal>
  </b-container>
</template>

<script>
import { ru } from 'vuejs-datepicker/dist/locale'
import Api from '@/services/Api'
import Datepicker from 'vuejs-datepicker'
import MaskedInput from 'vue-masked-input'

export default {
  components: {
    Datepicker,
    MaskedInput
  },
  name: 'Clients',
  props: {
    caption: {
      type: String,
      default: 'Сотрудники'
    },
    hover: {
      type: Boolean,
      default: true
    },
    striped: {
      type: Boolean,
      default: true
    },
    bordered: {
      type: Boolean,
      default: true
    },
    small: {
      type: Boolean,
      default: true
    }
  },
  data: () => {
    return {
      userLevel: localStorage.getItem('level'),
      ru: ru,
      validBirthday: true,
      items: [],
      cities: [],
      fields: [
        { key: 'name', sortable: true, label: 'Имя' },
        { key: 'lastName', sortable: true, label: 'Фамилия' },
        { key: 'birthday', sortable: true, label: 'Дата рождения' },
        { key: 'password', sortable: true, label: 'Пароль' },
        { key: 'phone', sortable: true, label: 'Телефон' },
        { key: 'email', sortable: true, label: 'Email' },
        { key: 'city', sortable: true, label: 'Город' },
        { key: 'IIN', sortable: true, label: 'ИИН' },
        { key: 'BIN', sortable: true, label: 'БИН' },
        { key: 'jurAddres', sortable: true, label: 'Юр адрес' },
        { key: 'companyName', sortable: true, label: 'Компания' },
        { key: 'action', label: 'Действия' }
      ],
      currentPage: 1,
      perPage: 10,
      totalRows: 0,
      rowCount: 1,
      filter: null,
      modalInfo: {
        _id: '',
        name: '',
        lastName: '',
        position: '',
        department: '',
        phone_1: '',
        birthday: '',
        email: '',
        city: '',
        IIN: '',
        BIN: '',
        jurAddres: '',
        companyName: ''
      },
      addedUser: {
        name: '',
        lastName: '',
        position: '',
        department: '',
        birthday: '',
        phone: '',
        email: '',
        type: 'client',
        city: '',
        IIN: '',
        BIN: '',
        jurAddres: '',
        companyName: '',
        status: 'active'
      }
    }
  },
  beforeMount () {
    this.getCities()
    this.getClients()
  },
  computed: {
    disabled () {
      if (this.addedUser.name.length > 0 && this.addedUser.lastName.length > 0 && this.addedUser.phone.length > 0) {
        return false
      } else {
        return true
      }
    },
    disabledEdit () {
      if (this.modalInfo.name.length > 0 && this.modalInfo.lastName.length > 0 && this.modalInfo.phone.length > 0) {
        return false
      } else {
        return true
      }
    }
  },
  methods: {
    isDisabled() {
      return this.userLevel === "2"
    },
    getCities () {
      Api().get('getCities').then(response => {
        this.cities = response.data.map(item => {
          return {
            value: item.name,
            text: item.name
          }
        })
      })
    },
    getClients () {
      Api().post('getByParameters', {type: 'client'}).then(response => {
        this.items = response.data
        this.rowCount = response.data.length
      })
    },
    adding () {
      //TODO refactor, check
      this.$validator.validateAll()
      if (this.validateAdding()) {
        this.addedUser.type = 'client'
        this.addedUser.phone = this.addedUser.phone.replace(/\D+/g, "")
        if (this.addedUser.birthday) {
          let b = this.addedUser.birthday.trim().split('.')
          this.addedUser.birthday = new Date(b[2], b[1] - 1, b[0])
        }
        Api().post('adduser', this.addedUser).then(response => {
          this.resetModal()
          window.location.reload()
        })
      }
    },
    edit () {
      //TODO refactor, check
      this.$validator.validateAll()
      if (this.validateEditing()) {
        this.modalInfo.phone = this.modalInfo.phone.replace(/\D+/g, "")
        if (this.modalInfo.birthday) {
          let b = this.modalInfo.birthday.trim().split('.')
          this.modalInfo.birthday = new Date(b[2], b[1] - 1, b[0])
        }
        Api().post('edituser', this.modalInfo).then(response => {
          this.resetModal()
          window.location.reload()
        })
      }
    },
    deleting (_id) {
      const answer = confirm('Нажмите OK для продолжения или Cancel для выхода.')
      if (answer) {
        Api().post('deletingusers', {_id}).then(response => {
          if (response.data.n && response.data.n > 0) {
            this.resetModal()
            window.location.reload()
          } else {
            alert('ne udalilsya')
          }
        })
      } else {
        this.resetModal()
      }
    },
    validateAdding () {
      if (this.addedUser.birthday && this.addedUser.birthday.replace(/\D+/g, "").length < 8) {
        this.validBirthday = false
      } else {
        this.validBirthday = true
      }
      if (this.addedUser.name.length > 0 && this.addedUser.lastName.length > 0 && this.addedUser.phone.length > 0 && this.validBirthday) {
        return true
      } else {
        return false
      }
    },
    validateEditing () {
      if (this.modalInfo.birthday && this.modalInfo.birthday.replace(/\D+/g, "").length < 8) {
        this.validBirthday = false
      } else {
        this.validBirthday = true
      }
      if (this.modalInfo.name.length > 0 && this.modalInfo.lastName.length > 0 && this.modalInfo.phone.length > 0 && this.validBirthday) {
        return true
      } else {
        return false
      }
    },
    info (_item) {
      this.modalInfo = {}
      this.modalInfo = _item
      if (_item.birthday) {
        this.modalInfo.birthday = this.dateFormat(_item.birthday)
      }
      this.$root.$emit('bv::show::modal', 'modalInfo')
    },
    dateFormat (_date) {
      _date = _date.toString().trim()
      function fmt (n) {
        return n > 9 ? n : '0' + n
      }
      const now = new Date(_date)
      if (now != 'Invalid Date' && _date.length > 11) {
        _date = fmt(now.getDate()) + '.' + fmt(now.getMonth() + 1) + '.' + fmt(now.getFullYear())
        const time = fmt(now.getHours()) + ':' +  fmt(now.getMinutes())
      }
      return _date
    },
    resetModal () {
      this.modalInfo.title = ''
      this.modalInfo.content = ''
      this.modalInfo.birthday = ''
      this.addedUser.login = ''
      this.addedUser.name = ''
      this.addedUser.lastName = ''
      this.addedUser.position = ''
      this.addedUser.department = ''
      this.addedUser.phone = ''
      this.addedUser.email = ''
      this.addedUser.IIN = ''
      this.addedUser.BIN = ''
      this.addedUser.jurAddres = ''
      this.addedUser.companyName = ''
      this.addedUser.city = ''
      this.addedUser.birthday = ''
      this.errors.clear()
    },
    onFiltered (filteredItems) {
      this.rowCount = filteredItems.length
      this.currentPage = 1
    },
    openAddingModal () {
      this.$root.$emit('bv::show::modal', 'addingModal')
    }
  }
}
</script>
